<!--
  ~ (c) Copyright 2024 Swiss Post Ltd.
  -->
<div class="modal-header">
	<h1 class="h4 modal-title">{{ 'candidateselection.title' | translate }}</h1>
	<button
			(click)="activeModal.dismiss()"
			[attr.aria-label]="'common.close' | translate"
			class="btn-close"
			type="button"
	></button>
</div>

<div class="modal-body">
	<form (submit)="searchTerm.setValue(searchTermInput.value)" aria-controls="resultCount" spellcheck="false">
		<h2 class="no-styling">
			<label class="form-label" for="candidate-search--term">
				{{ 'candidateselection.namefilter.label' | translate }}
			</label>
		</h2>

		<div class="input-group mb-3">
			<vp-clearable-input buttonLabel="candidateselection.namefilter.clear">
				<input
					#searchTermInput="ngModel"
					[ngModelOptions]="{ standalone: true }"
					class="form-control"
					id="candidate-search--term"
					ngModel
					type="text"
				>
			</vp-clearable-input>
			<button class="btn btn-outline-dark" id="candidate-search--submit" type="submit">
				<vp-icon name="search"></vp-icon>
				<span class="d-none d-sm-inline">{{ 'candidateselection.namefilter.search' | translate }}</span>
				<span class="d-sm-none visually-hidden">{{ 'candidateselection.namefilter.search' | translate }}</span>
			</button>
		</div>

		<ng-container [formGroup]="filters">
			<div *ngIf="contest.hasListQuestion" class="mb-3">
				<h2 class="no-styling">
					<label class="form-label" for="candidate-filter--list">
						{{ 'candidateselection.listfilter.label' | translate }}
					</label>
				</h2>

				<select class="form-select" formControlName="listId" id="candidate-filter--list">
					<option [ngValue]="null">{{ 'candidateselection.listfilter.alllists' | translate }}</option>
					<option *ngFor="let list of contest.realLists"
							[ngValue]="list.id">{{ list.details?.listType_attribute1 }}</option>
				</select>
			</div>

			<div *ngIf="contest.candidatesQuestion && contest.candidatesQuestion.cumul > 1"
				 class="form-check form-switch mb-3">
				<input
						class="form-check-input"
						formControlName="selectedCandidatesOnly"
						id="candidate-filter--selected"
						role="switch"
						type="checkbox"
				>
				<h2 class="no-styling">
					<label
							class="form-check-label"
							for="candidate-filter--selected"
					>{{ 'candidateselection.selectedonlyfilter' | translate }}</label>
				</h2>
			</div>
		</ng-container>
	</form>

	<p
			[class.visually-hidden]="contest.candidatesQuestion?.hasWriteIns"
			aria-live="polite"
			class="small fst-italic mb-0"
			id="resultCount"
	>
		<!-- no search -->
		<ng-container *ngIf="!searchTerm.value && candidates.length === 1">
			{{ 'candidateselection.searchresults.nosearch.singular' | translate : searchResultsArgs }}
		</ng-container>
		<ng-container *ngIf="!searchTerm.value && candidates.length > 1">
			{{ 'candidateselection.searchresults.nosearch.plural' | translate : searchResultsArgs }}
		</ng-container>

		<!-- search and results -->
		<ng-container *ngIf="searchTerm.value && filteredCandidates.length === 1">
			{{ 'candidateselection.searchresults.numberofresults.singular' | translate : searchResultsArgs }}
		</ng-container>
		<ng-container *ngIf="searchTerm.value && filteredCandidates.length > 1">
			{{ 'candidateselection.searchresults.numberofresults.plural' | translate : searchResultsArgs }}
		</ng-container>

		<!-- search but no results -->
		<ng-container *ngIf="searchTerm.value && !filteredCandidates.length">
			{{ 'candidateselection.searchresults.noresults' | translate }}
		</ng-container>
	</p>

	<h2 class="visually-hidden">
		<ng-container *ngIf="searchTerm.value; else noSearchTitle">
			{{ 'candidateselection.searchresults.title' | translate }}
		</ng-container>
		<ng-template #noSearchTitle>
			{{ 'candidateselection.searchresults.title.nosearch' | translate }}
		</ng-template>
	</h2>

	<ul class="list-group list-group-flush mt-3">
		<li *ngFor="let candidate of explicitCandidates" class="list-group-item">
			<vp-candidate-selector
					[candidateIndex]="candidateIndex"
					[candidate]="candidate"
					[contestUserData]="contestUserData"
					[electionContest]="contest"
			></vp-candidate-selector>
		</li>
	</ul>

	<div *ngIf="hasImplicitlyDiscreetCandidates" ngbAccordion>
		<div (hide)="isExpanded = false" (show)="isExpanded = true" [collapsed]="!isExpanded" ngbAccordionItem>
			<h2 ngbAccordionHeader>
				<button ngbAccordionButton>
					<span class="d-flex justify-content-between align-items-center w-100 pe-3">
                    <span class="d-block h6 mb-0">{{ 'choose.candidates.implicitly.discreet' | translate }}</span>
                    <span
							aria-hidden="true"
							class="d-none d-md-inline"
					>{{ (isExpanded ? 'common.hide' : 'common.show') | translate }}</span>
                  	</span>
				</button>
			</h2>
			<div ngbAccordionCollapse>
				<div *ngFor="let candidate of implicitDiscreetCandidates" ngbAccordionBody>
					<vp-candidate-selector
							[candidateIndex]="candidateIndex"
							[candidate]="candidate"
							[contestUserData]="contestUserData"
							[electionContest]="contest"
					></vp-candidate-selector>
				</div>
			</div>
		</div>
	</div>

	<div
			*ngIf="contest.candidatesQuestion?.hasWriteIns && contest.writeInCandidates[candidateIndex] as writeInCandidate"
			class="list-group list-group-flush border-top border-2 mt-3 pt-3"
	>
		<div class="list-group-item">
			<vp-candidate-selector
					[candidateIndex]="candidateIndex"
					[candidate]="writeInCandidate"
					[contestUserData]="contestUserData"
					[electionContest]="contest"
			></vp-candidate-selector>
		</div>
	</div>
</div>
